/*
   This example shows that the more user space buffering you
   give to printf(), the faster it can print out characters.
*/
#include <stdio.h>
#include <pthread.h>
#include <windows.h>  // for Sleep()

int count = 0;

int main()
{
   //thread function prototypes
   void *thread1(void *vargp);

   pthread_t tid[1];

   //setbuf(stdout, NULL);                 // no buffering, slowest
   //setvbuf (stdout, NULL, _IOFBF, 2);    // very small buffer
   //setvbuf (stdout, NULL, _IOFBF, 8);    // small buffer, pretty slow
   //setvbuf (stdout, NULL, _IOFBF, 4096); // large buffer, very fast

   count = 0;

   // create thread
   printf("Starting thread.\n");
   pthread_create(&(tid[0]), NULL, thread1, NULL);

   Sleep(1000);

   fprintf(stderr, "\ncount = %d\n", count);

   return 0;
}


void *thread1(void *vargp)
{
   while (1)
   {
      fprintf(stdout, "abcdefghijklmnopqrstuvwxyz");   
      count++;
   }
   return NULL;
}
